package com.uas.ops.diff.domain;

import java.io.Serializable;
import java.util.*;

public class Diff implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private List<String> deletes;
	private List<String> adds;
	private List<String> updates;

	public List<String> getDeletes() {
		return deletes;
	}

	public void setDeletes(List<String> deletes) {
		this.deletes = deletes;
	}

	public List<String> getAdds() {
		return adds;
	}

	public void setAdds(List<String> adds) {
		this.adds = adds;
	}

	public List<String> getUpdates() {
		return updates;
	}

	public void setUpdates(List<String> updates) {
		this.updates = updates;
	}

	/**
	 * 涉及的文件列表
	 * @return
	 */
	public List<String> getFileList() {
		List<String> list = new ArrayList<String>();
		list.addAll(this.adds);
		list.addAll(this.updates);
		// 不用考虑删除的
		return list;
	}

	public Diff() {
	}

	public Diff(Manifest lastManifest, Manifest newManifest) {
		assert null != newManifest;
		this.deletes = new ArrayList<String>();
		this.adds = new ArrayList<String>();
		this.updates = new ArrayList<String>();
		compare(lastManifest, newManifest);
	}

	private void compare(Manifest lastManifest, Manifest newManifest) {
		if (null == lastManifest && null != newManifest) {
			this.adds.add(newManifest.getPath());
		} else if (null == newManifest && null != lastManifest) {
			this.deletes.add(lastManifest.getPath());
		} else if (!lastManifest.getPath().equals(newManifest.getPath())) {
			this.deletes.add(lastManifest.getPath());
			this.adds.add(newManifest.getPath());
		} else if (lastManifest.getLastChanged() < newManifest.getLastChanged()) {
			if (null != lastManifest.getChildren() || null != newManifest.getChildren()) {
				Map<String, Manifest> lastMap = lastManifest.toMap();
				Map<String, Manifest> newMap = newManifest.toMap();
				Set<String> paths = new HashSet<String>(lastMap.keySet());
				paths.addAll(newMap.keySet());
				for (String path : paths) {
					compare(lastMap.get(path), newMap.get(path));
				}
			} else {
				this.updates.add(newManifest.getPath());
			}
		}
	}
}
