package com.uas.ops.diff.domain;

import java.io.PrintStream;
import java.io.Serializable;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Manifest implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String path;
	private String version;
	private long lastChanged;
	private List<Manifest> children;

	public Manifest() {
	}

	public Manifest(String path, String version, long lastChanged) {
		super();
		this.path = path;
		this.version = version;
		this.lastChanged = lastChanged;
	}

	public String getPath() {
		return path;
	}

	public void setPath(String path) {
		this.path = path;
	}

	public String getVersion() {
		return version;
	}

	public void setVersion(String version) {
		this.version = version;
	}

	/**
	 * 上次更新时间
	 */
	public long getLastChanged() {
		return lastChanged;
	}

	public void setLastChanged(long lastChanged) {
		this.lastChanged = lastChanged;
	}

	public List<Manifest> getChildren() {
		return children;
	}

	public void setChildren(List<Manifest> children) {
		this.children = children;
	}

	public void println(PrintStream stream) {
		println(stream, 0);
	}

	public void println(PrintStream stream, int i) {
		stream.println("L" + i + ": " + path + "=" + version);
		if (null != children) {
			for (Manifest child : children)
				child.println(stream, i+1);
		}
	}

	public Map<String, Manifest> toMap() {
		Map<String, Manifest> map = new HashMap<String, Manifest>();
		if (null != children) {
			for (Manifest child : children) {
				if (map.containsKey(child.getPath())) {
					if (map.get(child.getPath()).getVersion().compareTo(child.getVersion()) >= 0) {
						continue;
					}
				}
				map.put(child.getPath(), child);
			}
		}
		return map;
	}

}
