package com.uas.plugins.maven.ops.diff.plugin;

import com.uas.ops.diff.domain.Manifest;
import com.uas.plugins.maven.ops.diff.provider.DiffService;
import com.uas.plugins.maven.ops.diff.provider.ManifestService;
import com.uas.plugins.maven.ops.diff.util.ObjectUtils;
import org.apache.maven.plugin.MojoExecutionException;
import org.apache.maven.plugin.MojoFailureException;
import org.apache.maven.plugins.annotations.LifecyclePhase;
import org.apache.maven.plugins.annotations.Mojo;

import java.io.File;

@Mojo(name = "deploy", defaultPhase = LifecyclePhase.DEPLOY, threadSafe = true)
public class DeployMojo extends MyAbstractMojo {

	private ManifestService manifestService;

	private DiffService diffService;

	@Override
	public void execute() throws MojoExecutionException, MojoFailureException {
        manifestService = new ManifestService(this.repository, artifact.getGroupId(), artifact.getArtifactId());
        diffService = new DiffService(this.repository, artifact.getGroupId(), artifact.getArtifactId());

        File lastManifestFile = getLastManifestFile();
        File newManifestFile = getManifestFile();
        File newDiffFile = getDiffFile();
        if (null != newManifestFile && newManifestFile.exists() && null != newDiffFile && newDiffFile.exists()) {
            String fromVersion = "0";
            try {
                if (lastManifestFile.exists()) {
                    Manifest lastManifest = ObjectUtils.read(lastManifestFile);
                    fromVersion = lastManifest.getVersion();
                }
                Manifest newManifest = ObjectUtils.read(newManifestFile);
                String toVersion = newManifest.getVersion();
                manifestService.uploadManifest(newManifestFile);
                diffService.uploadDiff(fromVersion, toVersion, newDiffFile);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

	}

}
