package com.uas.plugins.maven.ops.diff.plugin;

import org.apache.maven.artifact.Artifact;
import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugins.annotations.Parameter;

import java.io.File;

/**
 * Created by Pro1 on 2017/6/15.
 */
public abstract class MyAbstractMojo extends AbstractMojo {

    @Parameter(defaultValue="${project.artifact}", required=true, readonly=true)
    protected Artifact artifact;

    /**
     * ops-diff-service接口地址
     */
    @Parameter(property = "repository", defaultValue = "http://localhost:23000/v1")
    protected String repository;

    /**
     * 清单文件
     */
    @Parameter(property = "manifestName", defaultValue = ".manifest")
    protected String manifestName;

    /**
     * 差异文件
     */
    @Parameter(property = "diffName", defaultValue = ".diff")
    protected String diffName;

    /**
     * 默认跳过不执行
     */
    @Parameter(property = "maven.diff.skip", defaultValue = "true")
    protected boolean skip;

    @Parameter(defaultValue = "${basedir}", required = true, readonly = true)
    protected File basedir;

    @Parameter(defaultValue = "${project.build.directory}", required = true, readonly = true)
    protected File targetdir;

    @Parameter(defaultValue = "${project.build.directory}/diff", required = true)
    protected File diffTarget;

    @Parameter(defaultValue = "${project.build.finalName}", required = true, readonly = true)
    protected String buildName;

    protected File getManifestFile() {
        if (null != manifestName) {
            return new File(targetdir, manifestName);
        }
        return null;
    }

    protected  boolean isSubversion() {
        File svnCtl = new File(basedir, ".svn");
        return svnCtl.exists();
    }

    protected  boolean isGit() {
        File gitCtl = new File(basedir, ".git");
        return gitCtl.exists();
    }

    protected File getLastManifestFile() {
        if (null != manifestName) {
            return new File(targetdir, manifestName + ".last");
        }
        return null;
    }

    protected File getDiffFile() {
        if (null != diffName) {
            return new File(targetdir, diffName);
        }
        return null;
    }

}
