package com.uas.plugins.maven.ops.diff.provider;

import com.uas.plugins.maven.ops.diff.util.HttpUtils;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by Pro1 on 2017/6/15.
 */
public class DiffService {

    private final String diffApi;
    private final String groupId;
    private final String artifactId;

    public DiffService(String repositoryUrl, String groupId, String artifactId) {
        this.diffApi = repositoryUrl + "/diff";
        this.groupId = groupId;
        this.artifactId = artifactId;
    }

    public void uploadDiff(String fromVersion, String toVersion, File sourceFile) throws Exception {
        Map<String, Object> data = new HashMap<String, Object>();
        data.put("groupId", this.groupId);
        data.put("artifactId", this.artifactId);
        data.put("fromVersion", fromVersion);
        data.put("toVersion", toVersion);
        HttpUtils.ResponseWrap resp = HttpUtils.upload(this.diffApi, data, sourceFile);
        if (!resp.isSuccess()) {
            throw new Exception(resp.getContent());
        }
    }

}
