package com.uas.plugins.maven.ops.diff.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class ObjectUtils {

	/**
	 * 写对象
	 * 
	 * @param obj
	 * @param file
	 * @throws Exception
	 */
	public static void write(Object obj, File file) throws Exception {
		if (file.getParentFile().exists() || file.getParentFile().mkdirs()) {
			ObjectOutputStream os = new ObjectOutputStream(new FileOutputStream(file));
			os.writeObject(obj);
			os.close();
		}
	}

	/**
	 * 读对象
	 * 
	 * @param file
	 * @return
	 * @throws Exception
	 */
	public static <T> T read(File file) throws Exception {
		if (file.exists()) {
			ObjectInputStream is = new ObjectInputStream(new FileInputStream(file));
			@SuppressWarnings("unchecked")
			T obj = (T) is.readObject();
			is.close();
			return obj;
		}
		return null;
	}

}
