package com.uas.plugins.maven.ops.diff.util;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

import org.tmatesoft.svn.core.SVNDepth;
import org.tmatesoft.svn.core.SVNException;
import org.tmatesoft.svn.core.wc.SVNRevision;
import org.tmatesoft.svn.core.wc2.ISvnObjectReceiver;
import org.tmatesoft.svn.core.wc2.SvnGetStatus;
import org.tmatesoft.svn.core.wc2.SvnOperationFactory;
import org.tmatesoft.svn.core.wc2.SvnStatus;
import org.tmatesoft.svn.core.wc2.SvnTarget;

public class SvnUtils {

	public static Map<File, SvnStatus> getTargetStatus(File target) throws SVNException {
		final Map<File, SvnStatus> statuses = new HashMap<File, SvnStatus>();
		SvnOperationFactory operationFactory = new SvnOperationFactory();
		SvnGetStatus statusOperation = operationFactory.createGetStatus();
		statusOperation.setSingleTarget(SvnTarget.fromFile(target));
		statusOperation.setDepth(SVNDepth.INFINITY);
		statusOperation.setRevision(SVNRevision.WORKING);
		statusOperation.setReportAll(true);
		statusOperation.setReceiver(new ISvnObjectReceiver<SvnStatus>() {

			@Override
			public void receive(SvnTarget target, SvnStatus status) throws SVNException {
				if (status.isVersioned())
					statuses.put(status.getPath(), status);
			}

		});
		statusOperation.run();
		return statuses;
	}

}
